﻿Imports System.IO
Imports System.ComponentModel
Imports System.Windows.Media
Imports System.Drawing.Color

Public Class Form1

    Private Sub btnCarregar_Click(sender As Object, e As EventArgs) Handles btnCarregar.Click
        Dim caminho As String = "F:\musicas\"
        Dim arrLista As New ArrayList
        Dim msg, titulo, valor As String
        Dim objValor As Object
        msg = "Informe o caminho completo dos arquivos. Ex: C:\dados\"
        titulo = "Arquivos mp3" ' define o titulo.
        valor = ""              ' define o valor padrao
        ' Exibe mensagem posicionada 
        objValor = InputBox(msg, titulo, valor, 700, 400)
        If objValor Is "" Then objValor = caminho

        Try
            obtemArquivos(caminho, arrLista)
            Dim infoArquivos = From file As IO.FileInfo In arrLista Select file.FullName, file.Length
            dgvMusicas.DataSource = infoArquivos.ToList
            formataGridView()

        Catch ex As Exception
            MessageBox.Show(ex.Message, "Erro", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub
    Public Sub obtemArquivos(ByVal diretorioRaiz As String, ByRef arrListaArquivos As ArrayList)

        If My.Computer.FileSystem.GetDirectoryInfo(diretorioRaiz).Name = "System Volume Information" Then
            Return
        End If

        Try
            For Each recursiveDir As String In My.Computer.FileSystem.GetDirectories(diretorioRaiz)
                Call obtemArquivos(recursiveDir, arrListaArquivos)
            Next

            Dim arquivos = From file In My.Computer.FileSystem.GetFiles(diretorioRaiz, FileIO.SearchOption.SearchTopLevelOnly) _
                           Order By file _
                           Select My.Computer.FileSystem.GetFileInfo(file)

            arrListaArquivos.AddRange(arquivos.ToList)
        Catch ex As Exception
            Throw ex
        End Try
    End Sub
    Private Sub Tm_Tick(sender As Object, e As EventArgs) Handles Tm.Tick
        Static posicao As Integer = 0
        Dim tempo As Integer
        Try
            If posicao < dgvMusicas.SelectedRows.Count Then
                Dim tocar As Integer = dgvMusicas.SelectedRows.Count - 1 - posicao
                Dim nomeMusica As String = CStr(dgvMusicas.SelectedRows(tocar).Cells(0).Value())
                tempo = PlayMedia(nomeMusica)
                posicao += 1
                Tm.Interval = tempo
                Tm.Start()
            End If
        Catch ex As Exception
            Throw ex
        End Try
    End Sub
    Private Function PlayMedia(titulo As String) As Integer
        Try
            Dim media_player As New MediaPlayer
            media_player.Open(New System.Uri(titulo))
            System.Threading.Thread.Sleep(3000) 'da tempo para carregar a midia
            Dim duration = media_player.NaturalDuration.TimeSpan
            Dim time As Integer
            time = CInt(duration.TotalMilliseconds)
            media_player.Play()
            Return time
            media_player.Close()
        Catch ex As Exception
            Throw ex
        End Try
    End Function

    Private Sub btnTocar_Click(sender As Object, e As EventArgs) Handles btnTocar.Click, btnSair.Click
        Try
            Tm.Interval = 100
            Tm.Start()
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Erro", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub
    Private Sub formataGridView()
        With dgvMusicas
            .AutoGenerateColumns = False
            .AutoSizeRowsMode = DataGridViewAutoSizeRowsMode.DisplayedCellsExceptHeaders
            .ColumnHeadersBorderStyle = DataGridViewHeaderBorderStyle.Single
            'altera a cor das linhas alternadas no grid
            .RowsDefaultCellStyle.BackColor = System.Drawing.Color.Aqua
            .AlternatingRowsDefaultCellStyle.BackColor = System.Drawing.Color.Aquamarine
            'altera o nome das colunas
            .Columns(0).HeaderText = "Nome do Arquivo"
            .Columns(1).HeaderText = "Tamanho"
            .Columns(0).Width = 500
            .Columns(1).Width = 100
            'seleciona a linha inteira
            .SelectionMode = DataGridViewSelectionMode.FullRowSelect
            'permite seleção de multiplas linhas
            .MultiSelect = True
            ' exibe nulos formatados
            .DefaultCellStyle.NullValue = " - "
            'permite que o texto maior que célula não seja truncado
            .DefaultCellStyle.WrapMode = DataGridViewTriState.True
            'define o alinhamamento 
            .Columns(1).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight
        End With
    End Sub
End Class
